
#    Note:  This is loaded into the namespace  ADC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable ADCList {0 1 2 3 4 5 6 7}
    variable ADC [first $ADCList]

    variable allmodules 0
    variable allADCs 0

    for {set i 0} {$i < 18} {incr i} {
        variable Opts.Value$i 0
    }

    variable         Opts.Offset0 0x00
    variable         Opts.Title0  "chip port config"

    variable         Opts.Offset1 0x01
    variable         Opts.Title1  "chip id"

    variable         Opts.Offset2 0x02
    variable         Opts.Title2  "chip grade"

    variable         Opts.Offset3 0x04
    variable         Opts.Title3  "device index 2"

    variable         Opts.Offset4 0x05
    variable         Opts.Title4  "device index 1"

    variable         Opts.Offset5 0xff
    variable         Opts.Title5  "device update"

    variable         Opts.Offset6 0x08
    variable         Opts.Title6  "modes"

    variable         Opts.Offset7 0x09
    variable         Opts.Title7  "clock"

    variable         Opts.Offset8 0x0d
    variable         Opts.Title8  "test i/o"

    variable         Opts.Offset9 0x14
    variable         Opts.Title9  "output mode"

    variable         Opts.Offset10 0x15
    variable         Opts.Title10  "output adjust"

    variable         Opts.Offset11 0x16
    variable         Opts.Title11  "output phase"

    variable         Opts.Offset12 0x19
    variable         Opts.Title12  "user pattern1 lsb"

    variable         Opts.Offset13 0x1a
    variable         Opts.Title13  "user pattern1 msb"

    variable         Opts.Offset14 0x1b
    variable         Opts.Title14  "user pattern2 lsb"

    variable         Opts.Offset15 0x1c
    variable         Opts.Title15  "user pattern2 msb"

    variable         Opts.Offset16 0x21
    variable         Opts.Title16  "serial control"

    variable         Opts.Offset17 0x22
    variable         Opts.Title17  "serial channel status"



   proc  show_variables {} {
       variable allmodules 
       variable allADCs
       variable ADC

#       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "ADC Chip = $ADC"
       InsertLog "all modules = $allmodules; all ADC Chips = $allADCs"

        InsertLog "[ReadAD9252Register $ADC 0]"
   }

   proc do_redisplay {} {
     variable ADC

     for {set i 0} {$i < 18} {incr i} {
       variable Opts.Value$i
       variable Opts.Offset$i
       set Opts.Value$i [ReadAD9252Register $ADC [set Opts.Offset$i]]
     }
   }

   proc do_setOpt {i vl} {
      variable ADC
      variable ADCList
      variable allADCs
      variable allmodules
      variable Opts.Offset$i

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
 
          foreach adc $ADCList {
              if {$allADCs == 0 && $adc != $ADC} continue
              WriteAD9252Register $adc [set Opts.Offset$i] $vl
              WriteAD9252Register $adc 0xff 1   ;# device update
          }
      }

      set ::AIDA::FEE64 $BAK
   }

   proc do_setOptB {i j vl} {
      variable ADC
      variable ADCList
      variable allADCs
      variable allmodules
      variable Opts.Offset$i
      variable Opts.Value$i

      set bmask [list 0x7f 0xbf 0xdf 0xef 0xf7 0xfb 0xfd 0xfe]

      set Opt [expr ([set Opts.Value$i] & [lindex $bmask $j]) | $vl]
      if {$vl == 1} {set Opt [expr $Opt | (0xff & ~[lindex $bmask $j])]}

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          foreach adc $ADCList {
              if {$allADCs == 0 && $adc != $ADC} continue
              set Opts.Value$i [format 0x%x $Opt]
          }
      }

      set ::AIDA::FEE64 $BAK
   }


   proc do_setOptS {i} {
      variable ADC
      variable ADCList
      variable allADCs
      variable allmodules
      variable Opts.Offset$i
      variable Opts.Value$i

      set BAK $::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          foreach adc $ADCList {
              if {$allADCs == 0 && $adc != $ADC} continue
              WriteAD9252Register $adc [set Opts.Offset$i] [set Opts.Value$i]
              WriteAD9252Register $adc 0xff 1   ;# device update
          }
 
      }

      set ::AIDA::FEE64 $BAK
   }





   proc DEFAULT {} {
       variable ADC
       variable ADCList
       variable allADCs
      variable allmodules

      set BAK ::AIDA::FEE64

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64

          foreach adc $ADCList {
             if {$allADCs == 0 && $adc != $ADC} continue
             for {set i 0} {$i < 18} {incr i} {
                 variable Opts.Offset$i
                 WriteAD9252Register $adc [set Opts.Offset$i] 0
             }
          }
      }
      set ::AIDA::FEE64 $BAK
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   ADC     {variable ADC; set ADC $vl}
                   ALLADCS {variable allADCs; set allADCs [expr ($allADCs + 1) & 1]}

                   OPT      {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   OPTB     {do_setOptB [second [lindex $cgidata 1]] [third [lindex $cgidata 1]] [fourth [lindex $cgidata 1]]; return}
                   OPTS     {do_setOptS [second [lindex $cgidata 1]]}

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

     do_redisplay

}   ;# end of if {$started == 0}




